/*
 * mkvmerge -- utility for splicing together matroska files
 * from component media subtypes
 *
 * Distributed under the GPL
 * see the file COPYING for details
 * or visit http://www.gnu.org/copyleft/gpl.html
 *
 * $Id: error.h 1925 2004-07-28 19:48:04Z mosu $
 *
 * class definitions for the error exception class
 *
 * Written by Moritz Bunkus <moritz@bunkus.org>.
 */

#ifndef __ERROR_H
#define __ERROR_H

#include <string>

#include "common.h"

using namespace std;

class MTX_DLL_API error_c {
private:
  string error;
public:
  error_c() {
    error = "unknown error";
  };
  error_c(char *nerror, bool freeit = false) {
    error = nerror;
    if (freeit)
      safefree(nerror);
  };
  error_c(const char *nerror) { error = nerror; };
  error_c(const string &nerror) { error = nerror; };
  error_c(const error_c &e) { error = e.error; };
  const char *get_error() const { return error.c_str(); };
  operator const char *() const { return error.c_str(); };
};

#endif // __ERROR_H
